package security.validators;

import org.springframework.beans.factory.annotation.Autowired;

import dao.entities.UserInfoDao;
import entities.UserInfo;
import exceptions.NonValidTokenException;
import security.TokenSessionManager;

public class NativeTokenValidator implements TokenValidator {

	@Autowired private TokenSessionManager tokenSessionManager; 
	@Autowired private UserInfoDao userInfoDao;
	
	@Override
	public UserInfo validateToken(String token) throws NonValidTokenException {
		String tokenUser = tokenSessionManager.getUser(token);
		if(tokenUser==null || tokenUser.isEmpty())
			throw new NonValidTokenException("Login session has expired! Need to login again!");
		return userInfoDao.getByUsername(tokenUser);
	}

	
	
	
}
