import { Component, OnInit, Input, Output, EventEmitter } from '@angular/core';
import { DataModel } from '../../entities/DataModel';

//import * as $ from '../../../../node_modules/jquery/dist/jquery'

import * as scroll from '../../../assets/jquery.scrollTo.min.js';

@Component({
  selector: 'toc',
  templateUrl: '/toc.component.html',
  styleUrls: ['./toc.component.css'],
  providers:  []
})
export class TocComponent implements OnInit{ 

    @Input() dataModel: DataModel;
    private headers = new Array();

    @Output()
    setPage:EventEmitter<number> = new EventEmitter<number>();

    ngOnInit(){
      var len =  this.dataModel.groups.length; // I don't use headers , I use datamodel.groupfields
      for (var i=0; i<len; i++){
        this.headers.push (this.dataModel.groups[i].title)
      }

    }

    scrollToElemID(elemID, _page){
      console.log("going to id:"+elemID)
      var page = parseInt(_page)
      this.setPage.emit(page);
      scroll("#"+elemID, {}, {offset: top});
    }

}